INCLUDE(FindPkgConfig)
PKG_CHECK_MODULES(PC_DVBPARTS DVBparts)

FIND_PATH(
    DVBPARTS_INCLUDE_DIRS
    NAMES DVBparts/api.h
    HINTS $ENV{DVBPARTS_DIR}/include
        ${PC_DVBPARTS_INCLUDEDIR}
    PATHS ${CMAKE_INSTALL_PREFIX}/include
          /usr/local/include
          /usr/include
)

FIND_LIBRARY(
    DVBPARTS_LIBRARIES
    NAMES gnuradio-DVBparts
    HINTS $ENV{DVBPARTS_DIR}/lib
        ${PC_DVBPARTS_LIBDIR}
    PATHS ${CMAKE_INSTALL_PREFIX}/lib
          ${CMAKE_INSTALL_PREFIX}/lib64
          /usr/local/lib
          /usr/local/lib64
          /usr/lib
          /usr/lib64
          )

include("${CMAKE_CURRENT_LIST_DIR}/DVBpartsTarget.cmake")

INCLUDE(FindPackageHandleStandardArgs)
FIND_PACKAGE_HANDLE_STANDARD_ARGS(DVBPARTS DEFAULT_MSG DVBPARTS_LIBRARIES DVBPARTS_INCLUDE_DIRS)
MARK_AS_ADVANCED(DVBPARTS_LIBRARIES DVBPARTS_INCLUDE_DIRS)
