/* -*- c++ -*- */
/* 
 * Copyright 2018 <+YOU OR YOUR COMPANY+>.
 * 
 * This is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3, or (at your option)
 * any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street,
 * Boston, MA 02110-1301, USA.
 */


#ifndef INCLUDED_DVBPARTS_PLPSELECTOR_H
#define INCLUDED_DVBPARTS_PLPSELECTOR_H

#include <DVBparts/api.h>
#include <gnuradio/block.h>

namespace gr {
  namespace DVBparts {

    /*!
     * \brief <+description of block+>
     * \ingroup DVBparts
     *
     */
    class DVBPARTS_API PLPselector : virtual public gr::block
    {
     public:
      typedef boost::shared_ptr<PLPselector> sptr;

      /*!
       * \brief Return a shared_ptr to a new instance of DVBparts::PLPselector.
       *
       * To avoid accidental use of raw pointers, DVBparts::PLPselector's
       * constructor is in a private implementation
       * class. DVBparts::PLPselector::make is the public interface for
       * creating new instances.
       *
       * Select PLP according to tagging.
       *
       * \param plp_id ID of PLP to select
       *
       */
      static sptr make( int plp_id = -1 );

      virtual void set_plp_id( int plp_id ) = 0;

    };

  } // namespace DVBparts
} // namespace gr

#endif /* INCLUDED_DVBPARTS_PLPSELECTOR_H */

