/* -*- c++ -*- */
/* 
 * Copyright 2017 Ingo D. Rullhusen <d01c@freeshell.de>.
 * 
 * This is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3, or (at your option)
 * any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street,
 * Boston, MA 02110-1301, USA.
 */


#ifndef INCLUDED_DVBPARTS_PILOT_REMOVE_RENORM_H
#define INCLUDED_DVBPARTS_PILOT_REMOVE_RENORM_H

#include <DVBparts/api.h>
#include <gnuradio/block.h>

namespace gr {
  namespace DVBparts {

    /*!
     * \brief <+description of block+>
     * \ingroup DVBparts
     *
     */
    class DVBPARTS_API pilot_remove_renorm : virtual public gr::block
    {
     public:
      typedef boost::shared_ptr<pilot_remove_renorm> sptr;

      /*!
       * \brief Return a shared_ptr to a new instance of DVBparts::pilot_remove_renorm.
       *
       * To avoid accidental use of raw pointers, DVBparts::pilot_remove_renorm's
       * constructor is in a private implementation
       * class. DVBparts::pilot_remove_renorm::make is the public interface for
       * creating new instances.
       *
       * Output stream tagged with L1_Pre information, renormed by pilot carriers,
       * pilots removed, and frequency deinterleaved.
       */
      static sptr make();
    };

  } // namespace DVBparts
} // namespace gr

#endif /* INCLUDED_DVBPARTS_PILOT_REMOVE_RENORM_H */

