/* -*- c++ -*- */
/* 
 * Copyright 2018 Ingo D. Rullhusen <d01c@freeshell.de>.
 * 
 * This is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3, or (at your option)
 * any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street,
 * Boston, MA 02110-1301, USA.
 */

#ifndef INCLUDED_DVBPARTS_BBDESCRAMBLER_IMPL_H
#define INCLUDED_DVBPARTS_BBDESCRAMBLER_IMPL_H

#include <DVBparts/BBdescrambler.h>

#include <DVBparts/bch_decoder.h>

#include "L1Post.h"


#define BB_SIZE_MAX 53840


namespace gr {
  namespace DVBparts {

    class BBdescrambler_impl : public BBdescrambler
    {
     private:
      int NBB;

      pmt::pmt_t PLPTagValue;
      L1Pplp l1plp;

      unsigned int descrambler_offset;
      bool descrambler[BB_SIZE_MAX];

      void init_descrambler(void);

     public:
      BBdescrambler_impl();
      ~BBdescrambler_impl();

      // Where all the action really happens
      int work(int noutput_items,
         gr_vector_const_void_star &input_items,
         gr_vector_void_star &output_items);
    };

  } // namespace DVBparts
} // namespace gr

#endif /* INCLUDED_DVBPARTS_BBDESCRAMBLER_IMPL_H */

