/* -*- c++ -*- */
/* 
 * Copyright 2018 Ingo D. Rullhusen <d01c@freeshell.de>.
 * 
 * This is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3, or (at your option)
 * any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street,
 * Boston, MA 02110-1301, USA.
 */

#ifndef L1PRE_H
#define L1PRE_H

#include <pmt/pmt.h>


typedef struct{
   unsigned int type; // 8
   unsigned int bwt_ext; // 1
   unsigned int s1; // 3
   unsigned int s2; // 4
   unsigned int l1_repetition_flag; // 1
   unsigned int guard_interval; // 3
   unsigned int papr; // 4
   unsigned int l1_mod; // 4
   unsigned int l1_cod; // 2
   unsigned int l1_fec_type; // 2 
   unsigned int l1_post_size; // 18
   unsigned int l1_post_info_size; // 18
   unsigned int pilot_pattern; // 4
   unsigned int tx_id_availability; // 8
   unsigned int cell_id; // 16
   unsigned int network_id; // 16
   unsigned int t2_system_id; // 16
   unsigned int num_t2_frames; // 8
   unsigned int num_data_symbols; // 12
   unsigned int regen_flag; // 3
   unsigned int l1_post_extension; // 1
   unsigned int num_rf; // 3
   unsigned int current_rf_index; // 3
   unsigned int t2_version; // 4
   unsigned int l1_post_scrambled; // 1
   unsigned int t2_base_lite; // 1
   unsigned int reserved; // 4
   unsigned int crc_32; // 32
} L1Pre;


void setup_L1pre( L1Pre &l1p, const unsigned char *L1pre );

void l1pre_out( const L1Pre &l1p );


void setup_L1tag( pmt::pmt_t &L1TagValue, const L1Pre &l1p );

void setup_L1pre( L1Pre &l1p, const pmt::pmt_t &L1TagValue );


#endif
