/* -*- c++ -*- */
/* 
 * Copyright 2017 Ingo D. Rullhusen <d01c@freeshell.de>.
 * 
 * This is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3, or (at your option)
 * any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street,
 * Boston, MA 02110-1301, USA.
 */

#ifndef INCLUDED_DVBPARTS_P1_DETECT_IMPL_H
#define INCLUDED_DVBPARTS_P1_DETECT_IMPL_H

#include <DVBparts/P1_Detect.h>

namespace gr {
  namespace DVBparts {

    class DVBPARTS_API P1_Detect_impl : public P1_Detect
    {
    private:
      int d_TA, d_TB, d_TC, d_TR;

      gr_complex accDTR1, accDTR2;

      int d_proc_size;

      gr_complex *EXPO, *EXPO_TC;
      gr_complex *C1t, *CORR_1, *C2t, *CORR_2, *CTMP1, *CTMP2, *CTMP3;
      float *FTMP1, *FTMP2;

      float invNq, rms, norm;

     public:
      P1_Detect_impl(int TA, int TB, int TC);
      ~P1_Detect_impl();

      // Where all the action really happens
      int work(int noutput_items,
         gr_vector_const_void_star &input_items,
         gr_vector_void_star &output_items);
    };

  } // namespace DVBparts
} // namespace gr

#endif /* INCLUDED_DVBPARTS_P1_DETECT_IMPL_H */
