/* -*- c++ -*- */
/* 
 * Copyright 2018 Ingo D. Rullhusen <d01c@freeshell.de>.
 * 
 * This is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3, or (at your option)
 * any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street,
 * Boston, MA 02110-1301, USA.
 */

#include "PLPslice.h"


void setup_PLPslicetag( pmt::pmt_t &SliceTagValue, const PLPslice &plpslice )
{
   pmt::pmt_t plptag;
   setup_L1Pplp_tag( plptag, plpslice.l1plp );

   SliceTagValue = pmt::make_tuple(
      pmt::from_long(plpslice.length),
      pmt::from_long(plpslice.frame_idx),
      pmt::from_long(plpslice.sub_slice_idx),
      pmt::from_long(plpslice.Nsubslices),
      pmt::from_long(plpslice.N_BLOCKS_IF),
      plptag
                                  );

}

void setup_PLPslice( PLPslice &plpslice, const pmt::pmt_t &SliceTagValue )
{
   plpslice.start = 0;

   plpslice.length = pmt::to_long(pmt::tuple_ref(SliceTagValue,0));
   plpslice.frame_idx = pmt::to_long(pmt::tuple_ref(SliceTagValue,1));
   plpslice.sub_slice_idx = pmt::to_long(pmt::tuple_ref(SliceTagValue,2));
   plpslice.Nsubslices = pmt::to_long(pmt::tuple_ref(SliceTagValue,3));
   plpslice.N_BLOCKS_IF = pmt::to_long(pmt::tuple_ref(SliceTagValue,4));

   setup_L1Pplp( plpslice.l1plp, pmt::tuple_ref(SliceTagValue,5) );

}

