/* -*- c++ -*- */
/* 
 * Copyright 2018 Ingo D. Rullhusen <d01c@freeshell.de>.
 * 
 * This is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3, or (at your option)
 * any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street,
 * Boston, MA 02110-1301, USA.
 */

#ifndef INCLUDED_DVBPARTS_BIT_DEINTERLEAVER_IMPL_H
#define INCLUDED_DVBPARTS_BIT_DEINTERLEAVER_IMPL_H

#include <DVBparts/bit_deinterleaver.h>

#include "L1Post.h"

namespace gr {
  namespace DVBparts {

    class bit_deinterleaver_impl : public bit_deinterleaver
    {
     private:
      pmt::pmt_t PLPTagValue;
      L1Pplp l1plp;

      int fec_size;

     public:
      bit_deinterleaver_impl();
      ~bit_deinterleaver_impl();

      // Where all the action really happens
      int work(int noutput_items,
         gr_vector_const_void_star &input_items,
         gr_vector_void_star &output_items);
    };

  } // namespace DVBparts
} // namespace gr

#endif /* INCLUDED_DVBPARTS_BIT_DEINTERLEAVER_IMPL_H */

