/* -*- c++ -*- */
/* 
 * Copyright 2015,2016 Free Software Foundation, Inc.
 *
 * Copyright 2018 Ingo D. Rullhusen <d01c@freeshell.de>.
 * 
 * This is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3, or (at your option)
 * any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street,
 * Boston, MA 02110-1301, USA.
 */

#define CRC_POLY 0x04C11DB7

bool check_crc32(unsigned char *in, int length)
{
   unsigned int crc = 0xffffffff;
   unsigned int b;
   int i = 0;   

   for (int n = 0; n < length - 32; n++)
   {
      b = (in[i++] & 0x01) ^ ((crc >> 31) & 0x01);
      crc <<= 1;
      if (b) { crc ^= CRC_POLY; } 
   }

   bool result = true;
   for ( unsigned int mask=0x80000000; mask>0; mask>>=1 )
   {
      result &= ( (in[i++]&0x01) == ( (crc & mask) ? 1 : 0 ) );
   }

   return(result);
}
