/* -*- c++ -*- */
/* 
 * Copyright 2018 Ingo D. Rullhusen <d01c@freeshell.de>.
 * 
 * This is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3, or (at your option)
 * any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street,
 * Boston, MA 02110-1301, USA.
 */

#ifndef INCLUDED_DVBPARTS_DEMODULATOR_SOFT_IMPL_H
#define INCLUDED_DVBPARTS_DEMODULATOR_SOFT_IMPL_H

#include <DVBparts/demodulator_soft.h>
#include <gnuradio/dtv/dvb_config.h>

#include "L1Post.h"


#define FRAME_SIZE_NORMAL 64800


namespace gr {
  namespace DVBparts {

    class demodulator_soft_impl : public demodulator_soft
    {
     private:
      pmt::pmt_t PLPTagValue;
      L1Pplp l1plp;

      int cell_size, fec_size, eta_mod, eta_mod_2, q_steps;

      float forecast_f;

      float *c_re, *c_im, *c_t;

      int get_symbits( unsigned char *symbits, double i_re, double i_im );

     public:
      demodulator_soft_impl();
      ~demodulator_soft_impl();

      // Where all the action really happens
      void forecast (int noutput_items, gr_vector_int &ninput_items_required);

      int general_work(int noutput_items,
           gr_vector_int &ninput_items,
           gr_vector_const_void_star &input_items,
           gr_vector_void_star &output_items);
    };

  } // namespace DVBparts
} // namespace gr

#endif /* INCLUDED_DVBPARTS_DEMODULATOR_SOFT_IMPL_H */

