/* -*- c++ -*- */
/* 
 * Copyright 2018 Ingo D. Rullhusen <d01c@freeshell.de>.
 * 
 * This is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3, or (at your option)
 * any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street,
 * Boston, MA 02110-1301, USA.
 */

#ifndef INCLUDED_DVBPARTS_TIME_DEINTERLEAVER_IMPL_H
#define INCLUDED_DVBPARTS_TIME_DEINTERLEAVER_IMPL_H

#include <DVBparts/time_deinterleaver.h>

#include "PLPslice.h"

#define TI_BUFFER_SIZE 557056  // 2^19+2^15

namespace gr {
  namespace DVBparts {

    class time_deinterleaver_impl : public time_deinterleaver
    {
     private:
      unsigned int ti_buffer_offset;
      gr_complex ti_buffer[ TI_BUFFER_SIZE ];

      PLPslice PLPsl;
      pmt::pmt_t PLPTagValue;

     public:
      time_deinterleaver_impl();
      ~time_deinterleaver_impl();

      // Where all the action really happens
      void forecast (int noutput_items, gr_vector_int &ninput_items_required);

      int general_work(int noutput_items,
           gr_vector_int &ninput_items,
           gr_vector_const_void_star &input_items,
           gr_vector_void_star &output_items);
    };

  } // namespace DVBparts
} // namespace gr

#endif /* INCLUDED_DVBPARTS_TIME_DEINTERLEAVER_IMPL_H */

