/* -*- c++ -*- */
/*
 * Copyright 2021 Ingo D. Rullhusen <d01c@freeshell.de>.
 *
 * This is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3, or (at your option)
 * any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street,
 * Boston, MA 02110-1301, USA.
 */

#ifndef INCLUDED_DVBPARTS_XCOPY_IMPL_H
#define INCLUDED_DVBPARTS_XCOPY_IMPL_H

#include <DVBparts/xcopy.h>

namespace gr {
  namespace DVBparts {

    class xcopy_impl : public xcopy
    {
     private:
      bool d_enabled;

     public:
      xcopy_impl(bool enable);
      ~xcopy_impl();

      void set_enabled(bool enable);

      // Where all the action really happens
      void forecast (int noutput_items, gr_vector_int &ninput_items_required);

      int general_work(int noutput_items,
           gr_vector_int &ninput_items,
           gr_vector_const_void_star &input_items,
           gr_vector_void_star &output_items);

    };

  } // namespace DVBparts
} // namespace gr

#endif /* INCLUDED_DVBPARTS_XCOPY_IMPL_H */

